#include <string>
#include <map>
#include <istream>
#include <boost/optional.hpp>

namespace TagMachine {

    typedef enum {
        TAG_VORBIS,
    } tag_format_t;

    boost::optional<tag_format_t>
    find_format_by_name(const std::string& str);

    tag_format_t
    force_find_format_by_name(const std::string& str);

    class AbstractTag {
    public:
        boost::optional<std::string>  title;
        boost::optional<std::string>  artist;
        boost::optional<std::string>  album;
        boost::optional<std::string>  comment;
        boost::optional<std::string>  genre;
        boost::optional<int>          year;
        boost::optional<unsigned int> tracknumber;

    public:
        AbstractTag() {}
        AbstractTag(std::istream& is, tag_format_t fmt);

        void write(std::ostream& os, tag_format_t fmt);

    private:
        void read_from_vorbis_tag(std::istream& is);
        void write_to_vorbis_tag(std::ostream& os);
    };

}
